/****
 * CStarterPane.h
 *
 *	Pane class for a typical application.
 *
 ****/

#define _H_CStarterPane			/* Include this file only once */
#include <CPanorama.h>

struct CStarterPane : CPanorama {
									/** Contruction/Destruction **/
	void		IStarterPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing);

									/** Drawing **/
	void		Draw(Rect *area);

									/** Mouse **/
	void		DoClick(Point hitPt, short modifierKeys, long when);
	Boolean		HitSamePart(Point pointA, Point pointB);
	
									/** Cursor **/
	void		AdjustCursor(Point where, RgnHandle mouseRgn);

									/** Scrolling **/
	void		ScrollToSelection(void);
};
